# -*- coding: utf-8 -*-
#def unimap_all(field,camera = 'camera',higal='higal'):
import os
import shutil
import sys
from string import *
from org.python.core import PyList
from javax.swing import *
from herschel.ia.numeric import *
from herschel.ia.io.fits import *
from herschel.ia.io.fits.FitsArchive import *
from herschel.ia.dataset import *
from herschel.ia.toolbox.util import *
from herschel.ia.gui.plot import *
from herschel.pacs.cal import *
from herschel.pacs.toolboxes.all import *
from java.util import Date
from java.lang import Runtime
from herschel.ia.task import *
from java.lang import Boolean
from herschel.ia.pal import *
from herschel.ia.obs import ObservationContext
from herschel.ia.pal.query import MetaQuery
from herschel.ia.pal.pool.lstore import LocalStoreFactory
from herschel.ia.pal.browser.v2.table.model import * 
from herschel.ia.pal.util import StorageResult
from herschel.ia.pal.pool.hsa import HsaReadPool
from herschel.ia.numeric.toolbox import *
from herschel.ia.numeric.toolbox.basic import MAX
from herschel.ia.toolbox.util import SimpleFitsReaderTask
from os import sys

from herschel.spire.all import *
from herschel.spire.util import *
from herschel.ia.all import *
from herschel.ia.task.mode import *
from herschel.ia.pg import ProductSink
from java.lang import *
from java.util import *
from herschel.ia.obs.util import ObsParameter
from herschel.ia.pal.pool.lstore.util import TemporalPool
from herschel.spire.ia.pipeline.scripts.PARALLEL.PARALLEL_tasks import *
from herschel.spire.ia.pipeline.scripts.PARALLEL.PARALLEL_input import *
from herschel.spire.ia.scripts.tools.obsLoader import *

#HIPE9
#ascii = AsciiTableTool()
#ascii.formatter = CsvFormatter(delimiter = ' ')
#ascii.formatter.header=0
#ascii.formatter.commented=0
#table = ascii.load('input_hipe.dat')

#wdir = sys.path[1]
#is_script = wdir[len(wdir)-7:len(wdir)]
#if is_script != 'scripts':
#    print "directory mismatch! (scripts)"
#    sys.exit()
cwd = os.getcwd()
print 'cwd',cwd
#table = asciiTableReader(sys.path[1]+'/input_hipe.dat',tableType='SPACES')#,tableType='CVS')

table = asciiTableReader(cwd+'/input_hipe.dat',tableType='SPACES') #,tableType='CVS')

field = table[0].data[0]
channel = table[0].data[1]
#path = table[0].data[2]
os.remove('input_hipe.dat')
###########################################

if (channel == 'pacs_blue'):
    instrument = 'PACS'
    camera = 'blue'
if (channel == 'pacs_red'):
    instrument = 'PACS'
    camera = 'red'
if (channel == 'spire'):
    instrument = 'SPIRE'
if (channel == 'spire_lev0'): #disabilitare local
    instrument = 'SPIRE'

n_obs_int = JOptionPane.showInputDialog(None,"How many observations do you want to combine?")
n_obsids = int(n_obs_int)
obsids = String1d(n_obsids)

database = ""
possibleAnswers = ["HSA", "Local"]
while database == "":
    database = JOptionPane.showInputDialog(None, "Select a database to query level 1 products", \
    "Test", JOptionPane.QUESTION_MESSAGE, None, possibleAnswers, possibleAnswers[1])
if database == None:
    database = ""
###########################################
if database == 'HSA':
    #vect_obsids = String1d(int(n_obsids))
    label_obsids = range(n_obsids)
    
    fields = PyList()
    for i in range(n_obsids):
        fields.append(JTextField(1))
    
    myPanel = JPanel()
    myPanel.setLayout(BoxLayout(myPanel, BoxLayout.PAGE_AXIS))
    
    for i in range(n_obsids):
        myPanel.add(JLabel("obsID "+ str(label_obsids[i]+1)),BoxLayout)
        myPanel.add(fields[i],BoxLayout)
    #myPanel.add(Box.createHorizontalStrut(15))
    #myPanel.add(JLabel("y:"),BoxLayout)
    #myPanel.add(yField,BoxLayout)
    
    result = JOptionPane.showConfirmDialog(None, myPanel,  "Please obsIDs values", JOptionPane.OK_CANCEL_OPTION)
    
    for i in range(n_obsids):
        obsids[i] = fields[i].getText()

if database == 'Local':
    file = String1d(n_obsids)
    if instrument == 'PACS':
        question = 'PACS: Choose the level 1 FITS files from your database'
        choosertitle = 'PACS'
    else:
        question = 'SPIRE: Choose the directory where level 1 files are saved'
        choosertitle = 'SPIRE'
    for i in range(n_obsids):
        JOptionPane.showMessageDialog(None, question +" ( "+str(i)+" Selected )")
        fc =  JFileChooser()
        fc.setDialogTitle(choosertitle)
        if instrument == 'SPIRE': fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY)
        val = fc.showOpenDialog(None)
        if val == fc.APPROVE_OPTION:
            file[i] = str(fc.getSelectedFile())
        obsids[i] = str(i)

#########setting unimap parameter for interactive mode
#deleted in 4.5: 'glitch_amp - positive real - glitch detection amplification near bright sources (0 = suppressed, 4 suggested)',\

sys.path.append(cwd+'/Scripts')

results_list = PyList()
dim_samples = Int1d()
from unimap_spire import *
from unimap_pacs import *
from unimap_spire_lev0 import *

#saving meta-data for the final header
key = ['DATE-OBS','SPG','INSTRUME','BUNIT','WAVELNTH']

comment = ['average JD','standard product generator','instrument','unit','wavelength in micron']

julianDate = Double1d()
spg_vect = String1d()
wave_vect = String1d()

for i in range(n_obsids):
    if database == 'HSA':
        archive = HsaReadPool()
        store = ProductStorage()
        store.register(archive)
        print 'Performing meta query at the HSA for obsID:'
        print obsids[i]
        q = MetaQuery(ObservationContext,"p","p.meta['obsid'].value=='"+obsids[i]+"' and p.meta['instrument'].value=='"+instrument+"'")
        results_query = store.select(q)
        try:
            obs = results_query[0].product
        except herschel.share.io.HcssHttpGeneralSecurityException:
            JOptionPane.showMessageDialog(None, "You are not logged at the HSA or/and you are trying for accessing to proprietary data. \n Please make authentication procedure (also by using the tip reported in the README file) and start the unihipe tool again")
            sys.exit()
            #fields = [JTextField(1),JTextField(1)]
            #mylogin = JPanel()
            #mylogin.setLayout(BoxLayout(mylogin, BoxLayout.PAGE_AXIS))
            #mylogin.add(JLabel("You are not logged in at the HSA or/and you"),BoxLayout)
            #mylogin.add(JLabel("are trying accessing to proprietary data"),BoxLayout)
            #mylogin.add(JLabel(" "),BoxLayout)
            #mylogin.add(JLabel("Username"),BoxLayout)
            #mylogin.add(fields[0],BoxLayout)
            #mylogin.add(JLabel("Password"),BoxLayout)
            #mylogin.add(fields[1],BoxLayout)
            #login = JOptionPane.showConfirmDialog(None, mylogin,  "HSA login", JOptionPane.OK_CANCEL_OPTION)
            #Configuration.setProperty("hcss.ia.pal.pool.hsa.haio.apply_authentication","true") 
            #Configuration.setProperty("hcss.ia.pal.pool.hsa.haio.login_usr",fields[0].getText()) 
            #Configuration.setProperty("hcss.ia.pal.pool.hsa.haio.login_pwd",fields[1].getText())
            #obs = results_query[0].product
        startDate = obs.getMeta()['startDate'].time
        spg = obs.getMeta()['creator'].string[4:len(obs.getMeta()['creator'].string)]

        if instrument == 'SPIRE':
	    if (channel == 'spire_lev0'):
        	################# INSERISCO QUI LA PIPELINE ###############
        	#vengono disattivati waveletDeglitcher, bolometerResponseCorrection
        	#da indagare lpfResponseCorrection
                start_level="level0_5"
        	#create a logger for the pipeline
        	logger=TaskModeManager.getMode().getLogger()
        	#inizio della pipeline
        	# modifica del 04/07/2011 per riconoscere la direzione di scan
        	try:
        	    scandirect=obs.refs["auxiliary"].product.refs["UplinkProduct"].product["ObsRequestData"]["stringParameter"]['stringParamVal'].data[10]
        	except IndexError:
        	    scandirect=obs.refs["auxiliary"].product.refs["UplinkProduct"].product["observationRequest"]["stringParameter"]['stringParamVal'].data[10]
        	# Shift of time origin for plots
        	t0=obs.startDate.microsecondsSince1958()*1e-6
        	obsid=obs.obsid
        	print "processing OBSID=", obsid,"("+hex(obsid)+")"
        	# Extract from the observation context the calibration products that
        	# will be used in the script
        	#################################################
        	# MODIFICA DEL 2013 PER USARE IL FILE DI CALIBRAZIONE
        	# INTERNO ALLE OSSERVAZIONI
        	#
        	#cal=obs.calibration
        	bsmPos=obs.calibration.phot.bsmPos
        	lpfPar=obs.calibration.phot.lpfPar
        	detAngOff=obs.calibration.phot.detAngOff
        	elecCross=obs.calibration.phot.elecCross
        	optCross=obs.calibration.phot.optCross
        	chanTimeConst=obs.calibration.phot.chanTimeConst
        	chanNum=obs.calibration.phot.chanNum
        	#modifica del 03/05/2010 dall'ultima versione della pipeline
        	fluxConvList=obs.calibration.phot.fluxConvList
        	tempDriftCorrList=obs.calibration.phot.tempDriftCorrList
        	##############################################################
        	#
        	# Extract from the observation context the auxiliary products that
        	# will be used in the script
        	hpp=obs.auxiliary.pointing
        	siam=obs.auxiliary.siam
        	# Set this to FALSE if you don't want to use the ProductSink
        	# and do all the processing in memory
        	tempStorage=Boolean.TRUE
        	# From Level 0 to Level 0.5
        	if start_level=="level0":
        		# Make Engineering conversion of level 0 products
        		level0_5= engConversion(obs.level0,cal=obs.calibration, tempStorage=tempStorage)
        		# Add the result to the observation in level 0.5
        		obs.level0_5=level0_5
        	else:
        		level0_5=obs.level0_5
        	pass
        	# set the progress
        	start_progress=20
        	# counter for computing progress	
        	count=0
        	# From Level 0.5 to Level 1
        	if start_level=="level0" or start_level=="level0_5":
        		# Create Level1 context
        		level1=Level1Context(obsid)
        		bbids=level0_5.getBbids(0xa103)
        		nlines=len(bbids)
        		scanle= Int1d(nlines)
        		print "number of scan lines:",nlines
        		#
        		# Loop over scan lines
        		ilen=0
        		for bbid in bbids:
        			block=level0_5.get(bbid)
        			print "processing BBID="+hex(bbid)
        			# Now move to engineering data products
        			pdt  = block.pdt
        			nhkt = block.nhkt
        			if pdt == None:
        				logger.severe("Building block "+hex(bbid)+" doesn't contain a PDT. Cannot process this building block.")
        				print "Building block "+hex(bbid)+" doesn't contain a PDT. Cannot process this building block."
        				continue
        			if nhkt == None:
        				logger.severe("Building block "+hex(bbid)+" doesn't contain a NHKT. Cannot process this building block.")
        				print "Building block "+hex(bbid)+" doesn't contain a NHKT. Cannot process this building block."
        				continue
        			# access and attach turnaround data to the nominal scan line  (Modificato nell'ultima versione della pipeline)
        			bbCount=bbid & 0xFFFF
        			pdtLead=None
        			nhktLead=None
        			pdtTrail=None
        			nhktTrail=None
        			if bbCount >1:
        				blockLead=level0_5.get(0xaf000000L+bbCount-1)
        				pdtLead=blockLead.pdt
        				nhktLead=blockLead.nhkt
        				if pdtLead != None and pdtLead.sampleTime[-1] < pdt.sampleTime[0]-3.0:
        					pdtLead=None
        					nhktLead=None
        			if bbid < MAX(Long1d(bbids)):
        				blockTrail=level0_5.get(0xaf000000L+bbCount)
        				pdtTrail=blockTrail.pdt
        				nhktTrail=blockTrail.nhkt
        				if pdtTrail != None and pdtTrail.sampleTime[0] > pdt.sampleTime[-1]+3.0:
        					pdtTrail=None
        					nhktTrail=None
        			pdt=joinPhotDetTimelines(pdt,pdtLead,pdtTrail)
        			nhkt=joinNhkTimelines(nhkt,nhktLead,nhktTrail)
        			#
        			# calculate BSM angles
        			bat=calcBsmAngles(nhkt,bsmPos=bsmPos)
        			#
        			# create the SpirePointingProduct
        			spp=createSpirePointing(detAngOff=detAngOff,bat=bat,hpp=hpp,siam=siam)
        			#
        			# run electrical crosstalk correction
        			pdt=elecCrossCorrection(pdt,elecCross=elecCross)
        			#
        			# storage hipe version
        			processingVersion = pdt['History']['HistoryTasks']['BuildVersion'].data[0]
        			processingDescription = pdt['History']['HistoryTasks']['BuildVersion'].description
        			productDescription = pdt.meta['creator'].description
        			productVersion = pdt.meta['creator'].string[24:40]
        			#
        			# run the deglitch
        			##modifica del 03/05 dall'ultima versione della pipeline
#        			pdt=waveletDeglitcher(pdt, scaleMin=1.0, scaleMax=8.0, scaleInterval=5, holderMin=-1.9,\
#        				holderMax=-0.3, correlationThreshold=0.69)
        			#
        			#
        			# run electrical Low Pass Filter response correction
        			pdt=lpfResponseCorrection(pdt,lpfPar=lpfPar)
        			#
        			# run the flux conversion
        			#modifica del 03/05 dall'ultima versione della pipeline
        			fluxConv=fluxConvList.getProduct(pdt.meta["biasMode"].value,pdt.startDate)
        			#
        			pdt=photFluxConversion(pdt,fluxConv=fluxConv)
        			#
        			# run the temeperature drift correction
        			#modifica del 03/05 dall'ultima versione della pipeline
        			tempDriftCorr=tempDriftCorrList.getProduct(pdt.meta["biasMode"].value,pdt.startDate)
        			#
        			pdt=temperatureDriftCorrection(pdt,tempDriftCorr=tempDriftCorr)
        			#
        			# run bolometer time response correction
        			# riattivata il 03/06
#        			pdt=bolometerResponseCorrection(pdt,chanTimeConst=chanTimeConst)
        			#
        			# run optical crosstalk correction
        			pdt=photOptCrossCorrection(pdt,optCross=optCross)
        			#
        			# add pointing
        			psp=associateSkyPosition(pdt,spp=spp)
        			#
        			# cut the timeline back to scan line range
        			#inserisco il controllo sulla lunghezza del dato senza turnaround
        			psp2=cutPhotDetTimelines(psp)
        			len_notur=len(psp2.getSignal("PSWE4"))
        			# Fabiana 09/05/2011 introduco la keyword extend=True per introdurre i turnaround
        			psp=cutPhotDetTimelines(psp,extend=True)
        			len_tur=len(psp.getSignal("PSWE4"))
        			scanle[ilen]=(len_tur-len_notur)
        			ilen=ilen+1
        			#
        			# Store Photometer Scan Product in Level 1 product storage
        			if tempStorage:
        				ref=ProductSink.getInstance().save(psp)
        				level1.addRef(ref)
        			else:
        				level1.addProduct(psp)
        			#
        			#print "Completed BBID="+hex(bbid)
        			print "Completed BBID=0x%x (%i/%i)"%(bbid,count+1,nlines)
        			# set the progress
        			count=count+1
        			start_progress = 20+(60*count)/nlines
        		#
        		if level1.count == 0:
        			logger.severe("No scan line processed due to missing data. This observation CANNOT be processed!")
        			print "No scan line processed due to missing data. This observation CANNOT be processed!"
        			raise MissingDataException("No scan line processed due to missing data. This observation CANNOT be processed!")
        		#
        		obs.level1=level1
        		# promote to LEVEL1_PROCESSED
        		
        		#obs.obsState = ObservationContext.OBS_STATE_LEVEL1_PROCESSED
                ###### Fino a qui ##########
                results = unimap_spire_lev0(obs,scanle)
                dim_samples.append(results[0][0].dimensions[0])
	    else:
	        results = unimap_spire(obs)
	        dim_samples.append(results[0][0].dimensions[0])
        else:
            frames = PacsContext(obs.level1).averaged.getCamera(camera).product.selectAll()
            calTree = getCalTree()
            results = unimap_pacs(frames,calTree,camera)
    if database == 'Local':
        if instrument == 'SPIRE':
            obs = []
            list = os.listdir(file[i])        
            img = simpleFitsReader(file[i]+'/'+list[0])
            startDate = img.getMeta()['startDate'].time
            spg = img.getMeta()['creator'].string[4:len(img.getMeta()['creator'].string)]
            results = unimap_spire(obs,file[i])
        else:
            frames = simpleFitsReader(file[i])
            startDate = frames.getMeta()['startDate'].time
            spg = frames.getMeta()['creator'].string[4:len(frames.getMeta()['creator'].string)]
            dimension = frames.dimensions[0]
            if camera == 'red':
                if dimension != 16:
                    print 'Loaded frames are not red frames --STOP--'
                    sys.exit()
            if camera == 'blue':
                if dimension != 32:
                    print 'Loaded frames are not blue frames --STOP--'
                    sys.exit()
            calTree = getCalTree()
            results = unimap_pacs(frames,calTree,camera)
            dim_samples.append(results[0].dimensions[0])
            
    #computing JD    
    date = str(startDate)[0:10]
    time = str(startDate)[11:19]   
    date=date.split("-")
    dd=int(date[2])
    mm=int(date[1])
    yyyy=int(date[0])
    time=time.split(":")
    hh=float(time[0])
    min=float(time[1]) 
    sec=float(time[2])
    UT=hh+min/60+sec/3600
    if (100*yyyy+mm-190002.5)>0:
        sig=1
    else:
        sig=-1
    JD = 367*yyyy - int(7*(yyyy+int((mm+9)/12))/4) + int(275*mm/9) + dd + 1721013.5 + UT/24 - 0.5*sig +0.5
    julianDate.append(JD)
    
    spg_vect.append(spg)
    
    if instrument == 'PACS':
        if camera == 'red':
                wave = '160'
        else:
            blue = frames.getMeta()['blue'].string
            if blue == 'blue1':
                wave = '70'
            else:
                wave = '100'
        wave_vect.append(wave)
    
    results_list.append(results)    

JD_avg = str(MEAN(julianDate))
print spg_vect
ind = spg_vect.where(spg_vect == spg_vect[0])
if (len(ind.toInt1d()) != n_obsids):
    print 'WARNING!! you are combinining observations with different SPG! EXIT'
    sys.exit()
print wave_vect
if instrument == 'PACS':
    ind = wave_vect.where(wave_vect == wave_vect[0])
    if (len(ind.toInt1d()) != n_obsids):
        print 'WARNING!! you are mixing blue and green observations! EXIT'
        sys.exit()

#meta_value = String1d([JD_avg,spg,instrument,'MJy/sr'])

if instrument == 'SPIRE':
    camera=['PSW','PMW','PLW']
    waves = ['250','350','500']
    for jspire in range(3):        
        #n_bolo = results[0][jspire].dimensions[1]
        exists_path =  os.path.exists(cwd+'/'+field+'/'+camera[jspire])
        if exists_path == 0:
            os.mkdir(cwd+'/'+field+'/'+camera[jspire])
        for i in range(n_obsids):
            s = results_list[i][0][jspire].copy()
            r = results_list[i][1][jspire].copy()
            d = results_list[i][2][jspire].copy()
            f = results_list[i][3][jspire].copy()
            gb = results_list[i][4][jspire].copy()
            sc = results_list[i][6][jspire].copy()
            sp = results_list[i][7][jspire].copy()
            print 'Saving SPIRE '+camera[jspire]+' outputs'
            array = [s,r,d,f,gb,Int1d().append(results_list[0][5][jspire]),sc,sp]
            description = ['Signal','Ra','Dec','Flag','Good bolometers','Number bolometers'\
            ,'Scanning flag ', 'Number of samples']
            c=CompositeDataset()
            for j in range(len(array)):
                dataset = ArrayDataset(description=description[j])
                dataset.data = array[j]
                c[description[j]] = dataset
            p = Product(description='Unimap input')
            p[obsids[i]] = c
            fits = FitsArchive(reader=STANDARD_READER)
            fits.save(cwd+'/'+field+'/'+camera[jspire]+'/unimap_obsid_'+field+'_'+camera[jspire]+'_'+obsids[i]+'.fits',p)
            del array,p
            System.gc()
            
        m = TableDataset()
        meta_value = String1d([JD_avg,spg,instrument,'MJy/sr',waves[jspire]])
        #meta_value.append(waves[jspire])
        m['meta'] = Column(meta_value)
        meta_name = cwd+'/'+field+'/'+camera[jspire]+'/unimap_meta_'+camera[jspire]+'.dat'
        #meta_name = path_source+meta_root+'_'+camera[jspire]'.dat'
        asciiTableWriter(m,meta_name,writeHeader=False)
            
else:
    #n_bolo = results[0].dimensions[1]
    for i in range(n_obsids):
        exists_path =  os.path.exists(cwd+'/'+field+'/'+camera)
        if exists_path == 0:
            os.mkdir(cwd+'/'+field+'/'+camera)
        s = results_list[i][0].copy()
        r = results_list[i][1].copy()
        d = results_list[i][2].copy()
        f = results_list[i][3].copy()
        gb = results_list[i][4].copy()
        sc = results_list[i][6].copy()
        sp = results_list[i][7].copy()    
        print 'Saving PACS '+camera+' outputs'
        array = [s,r,d,f,gb,results_list[0][5],sc,sp]
        description = ['Signal','Ra','Dec','Flag','Good bolometers','Number bolometers'\
        ,'Scanning flag ', 'Number of samples']
        c=CompositeDataset()
        for j in range(len(array)):
            dataset = ArrayDataset(description=description[j])
            dataset.data = array[j]
            c[description[j]] = dataset
        p = Product(description='Unimap input')
        p[obsids[i]] = c
        fits = FitsArchive(reader=STANDARD_READER)
        fits.save(cwd+'/'+field+'/'+camera+'/unimap_obsid_'+field+'_'+camera+'_'+obsids[i]+'.fits',p)
        del array,p
        System.gc()
        
    m = TableDataset()
    meta_value = String1d([JD_avg,spg,instrument,'MJy/sr',wave])
    #meta_value.append(wave)
    m['meta'] = Column(meta_value)
    meta_name = cwd+'/'+field+'/'+camera+'/unimap_meta_'+camera+'.dat'
    #asciiTableWriter(m,meta_name,formatterHeader=False)
    asciiTableWriter(m,meta_name,writeHeader=False)
